/*
* client ӽ fork()ϴ  model 
* sample program...
*/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdlib.h>

/*
* tcpip_lib.c tcpip_lib.h ֻ ũ ٿ.
*/
#include "tcpip_lib.h"

/*  portȣ մϴ.   մϴ.*/
#define SERVICE_PORT    6905


/* client ӵ socket  ϴ  ϴ. */
int  acpt_sock;

void child_main(void);


int main(int argc, char *argv[])
{
    int     idx;
    int     fd;
    int     sockfd;
    struct  sockaddr_in client;
    struct  sigaction   act_ignore;

    /* 
    * background program  terminal  signal ߻ . (Control-C ) 
    * ʽ α׷ Ͽ θ process id 1 child μ .
    *  session ׷ leader ƴ μ 
    */
    if(fork() != 0) {
        /* child process ƴϸ  */
        exit(0);
    }
    
    /*
    * ο session Ͽ session׷ leader 
    * ο session terminal   .
    */
    if(setsid() == -1) {
        fprintf(stderr, "NEW SESSION ERROR: %s\n", strerror(errno));
        exit(1);
    }
    
    /*
    * μ home directory ROOT丮 .
    */
    if(chdir("/") == -1) {
        fprintf(stderr, "CHDIR ERROR: %s\n", strerror(errno));
        exit(1);
    }
    

    /*
    * ǥԷ/ǥ/ǥؿ ó    ϱ Ͽ /dev/null  openմϴ.
    */
    if((fd = open("/dev/null", O_RDWR)) == -1) {
        exit(1);
    }
    
    // ǥԷ  ϵ redirect ó.   
    // scanf(), fgets(..., stdin)  Լ ϳ Է ȵ.
    dup2(fd, 0); 

    // ǥ  ϵ redirect ó. 
    // printf()  Լ ϳ  ȵ
    dup2(fd, 1); 
    
    // ǥؿ  ϵ redirect ó. 
    // fprintf(stderr, ...) Լ ϳ  ȵ
    dup2(fd, 2); 

    close(fd);   // ʿ fd close

    
    /*
    * signal ó ʼ
    */
    memset(&act_ignore, 0x00, sizeof(act_ignore));
    act_ignore.sa_handler    = SIG_IGN;
    sigaction(SIGCLD,  &act_ignore, NULL);
    sigaction(SIGSEGV, &act_ignore, NULL);
    
    if((sockfd = TCPIPserver(SERVICE_PORT)) == -1) {
        /* TO-DO :  α  */
        exit(1);
    }
    
    while(1) {
        if((acpt_sock = TCPIPaccept(sockfd, &client)) == -1) {
            /* TO-DO :  α  */
            continue;
        }

        if(fork() == 0) {
            child_main();
            exit(0); // ݵ ϰ óؾ .
        } else {
            /* θ μ ӵ socket ʿǷ close. */
            close(acpt_sock);
        }
    }
    return 0;
}

void child_main(void)
{
    /* TO-DO:  Լ    մϴ. */

    /* 
    * TO-DO:   °  ۼ ü Ͽ մϴ. 
    * ʿ  Ͽ մϴ.
    */
    int recv_len;
    char recv_buf[4096];
    char send_buf[4096];
    
    while(1) {
        if((recv_len = TCPIPrecv(acpt_sock, recv_buf, 2048, 0)) == -1) {
            /* TO-DO :  α  */
            exit(1);
        }
        
        /* TO-DO : Է ͷ óϴ   */
        // ......
        
        if((TCPIPsend(acpt_sock, send_buf, 2048, 0)) == -1) {
            /* TO-DO :  α  */
            exit(1);
        }
    }
}
